<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for baseResultVO StructType
 * @subpackage Structs
 */
class BaseResultVO extends AbstractStructBase
{
    /**
     * The outFlag
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outFlag;
    /**
     * The outResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outResult;
    /**
     * Constructor method for baseResultVO
     * @uses BaseResultVO::setOutFlag()
     * @uses BaseResultVO::setOutResult()
     * @param string $outFlag
     * @param string $outResult
     */
    public function __construct($outFlag = null, $outResult = null)
    {
        $this
            ->setOutFlag($outFlag)
            ->setOutResult($outResult);
    }
    /**
     * Get outFlag value
     * @return string|null
     */
    public function getOutFlag()
    {
        return $this->outFlag;
    }
    /**
     * Set outFlag value
     * @param string $outFlag
     * @return \StructType\BaseResultVO
     */
    public function setOutFlag($outFlag = null)
    {
        // validation for constraint: string
        if (!is_null($outFlag) && !is_string($outFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outFlag, true), gettype($outFlag)), __LINE__);
        }
        $this->outFlag = $outFlag;
        return $this;
    }
    /**
     * Get outResult value
     * @return string|null
     */
    public function getOutResult()
    {
        return $this->outResult;
    }
    /**
     * Set outResult value
     * @param string $outResult
     * @return \StructType\BaseResultVO
     */
    public function setOutResult($outResult = null)
    {
        // validation for constraint: string
        if (!is_null($outResult) && !is_string($outResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outResult, true), gettype($outResult)), __LINE__);
        }
        $this->outResult = $outResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BaseResultVO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
