<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cancelReturnShipmentCode StructType
 * Meta information extracted from the WSDL
 * - type: tns:cancelReturnShipmentCode
 * @subpackage Structs
 */
class CancelReturnShipmentCode extends AbstractStructBase
{
    /**
     * The wsUserName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $wsUserName;
    /**
     * The wsPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $wsPassword;
    /**
     * The wsLanguage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $wsLanguage;
    /**
     * The fieldName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fieldName;
    /**
     * The returnCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $returnCode;
    /**
     * Constructor method for cancelReturnShipmentCode
     * @uses CancelReturnShipmentCode::setWsUserName()
     * @uses CancelReturnShipmentCode::setWsPassword()
     * @uses CancelReturnShipmentCode::setWsLanguage()
     * @uses CancelReturnShipmentCode::setFieldName()
     * @uses CancelReturnShipmentCode::setReturnCode()
     * @param string $wsUserName
     * @param string $wsPassword
     * @param string $wsLanguage
     * @param string $fieldName
     * @param string $returnCode
     */
    public function __construct($wsUserName = null, $wsPassword = null, $wsLanguage = null, $fieldName = null, $returnCode = null)
    {
        $this
            ->setWsUserName($wsUserName)
            ->setWsPassword($wsPassword)
            ->setWsLanguage($wsLanguage)
            ->setFieldName($fieldName)
            ->setReturnCode($returnCode);
    }
    /**
     * Get wsUserName value
     * @return string|null
     */
    public function getWsUserName()
    {
        return $this->wsUserName;
    }
    /**
     * Set wsUserName value
     * @param string $wsUserName
     * @return \StructType\CancelReturnShipmentCode
     */
    public function setWsUserName($wsUserName = null)
    {
        // validation for constraint: string
        if (!is_null($wsUserName) && !is_string($wsUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wsUserName, true), gettype($wsUserName)), __LINE__);
        }
        $this->wsUserName = $wsUserName;
        return $this;
    }
    /**
     * Get wsPassword value
     * @return string|null
     */
    public function getWsPassword()
    {
        return $this->wsPassword;
    }
    /**
     * Set wsPassword value
     * @param string $wsPassword
     * @return \StructType\CancelReturnShipmentCode
     */
    public function setWsPassword($wsPassword = null)
    {
        // validation for constraint: string
        if (!is_null($wsPassword) && !is_string($wsPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wsPassword, true), gettype($wsPassword)), __LINE__);
        }
        $this->wsPassword = $wsPassword;
        return $this;
    }
    /**
     * Get wsLanguage value
     * @return string|null
     */
    public function getWsLanguage()
    {
        return $this->wsLanguage;
    }
    /**
     * Set wsLanguage value
     * @param string $wsLanguage
     * @return \StructType\CancelReturnShipmentCode
     */
    public function setWsLanguage($wsLanguage = null)
    {
        // validation for constraint: string
        if (!is_null($wsLanguage) && !is_string($wsLanguage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wsLanguage, true), gettype($wsLanguage)), __LINE__);
        }
        $this->wsLanguage = $wsLanguage;
        return $this;
    }
    /**
     * Get fieldName value
     * @return string|null
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }
    /**
     * Set fieldName value
     * @param string $fieldName
     * @return \StructType\CancelReturnShipmentCode
     */
    public function setFieldName($fieldName = null)
    {
        // validation for constraint: string
        if (!is_null($fieldName) && !is_string($fieldName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fieldName, true), gettype($fieldName)), __LINE__);
        }
        $this->fieldName = $fieldName;
        return $this;
    }
    /**
     * Get returnCode value
     * @return string|null
     */
    public function getReturnCode()
    {
        return $this->returnCode;
    }
    /**
     * Set returnCode value
     * @param string $returnCode
     * @return \StructType\CancelReturnShipmentCode
     */
    public function setReturnCode($returnCode = null)
    {
        // validation for constraint: string
        if (!is_null($returnCode) && !is_string($returnCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnCode, true), gettype($returnCode)), __LINE__);
        }
        $this->returnCode = $returnCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelReturnShipmentCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
