<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvDocCargoVO StructType
 * @subpackage Structs
 */
class InvDocCargoVO extends AbstractStructBase
{
    /**
     * The unitId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unitId;
    /**
     * The unitName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unitName;
    /**
     * The eventId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eventId;
    /**
     * The eventName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eventName;
    /**
     * The reasonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reasonId;
    /**
     * The reasonName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reasonName;
    /**
     * The eventDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eventDate;
    /**
     * The eventTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eventTime;
    /**
     * The cityName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cityName;
    /**
     * The townName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $townName;
    /**
     * Constructor method for InvDocCargoVO
     * @uses InvDocCargoVO::setUnitId()
     * @uses InvDocCargoVO::setUnitName()
     * @uses InvDocCargoVO::setEventId()
     * @uses InvDocCargoVO::setEventName()
     * @uses InvDocCargoVO::setReasonId()
     * @uses InvDocCargoVO::setReasonName()
     * @uses InvDocCargoVO::setEventDate()
     * @uses InvDocCargoVO::setEventTime()
     * @uses InvDocCargoVO::setCityName()
     * @uses InvDocCargoVO::setTownName()
     * @param string $unitId
     * @param string $unitName
     * @param string $eventId
     * @param string $eventName
     * @param string $reasonId
     * @param string $reasonName
     * @param string $eventDate
     * @param string $eventTime
     * @param string $cityName
     * @param string $townName
     */
    public function __construct($unitId = null, $unitName = null, $eventId = null, $eventName = null, $reasonId = null, $reasonName = null, $eventDate = null, $eventTime = null, $cityName = null, $townName = null)
    {
        $this
            ->setUnitId($unitId)
            ->setUnitName($unitName)
            ->setEventId($eventId)
            ->setEventName($eventName)
            ->setReasonId($reasonId)
            ->setReasonName($reasonName)
            ->setEventDate($eventDate)
            ->setEventTime($eventTime)
            ->setCityName($cityName)
            ->setTownName($townName);
    }
    /**
     * Get unitId value
     * @return string|null
     */
    public function getUnitId()
    {
        return $this->unitId;
    }
    /**
     * Set unitId value
     * @param string $unitId
     * @return \StructType\InvDocCargoVO
     */
    public function setUnitId($unitId = null)
    {
        // validation for constraint: string
        if (!is_null($unitId) && !is_string($unitId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unitId, true), gettype($unitId)), __LINE__);
        }
        $this->unitId = $unitId;
        return $this;
    }
    /**
     * Get unitName value
     * @return string|null
     */
    public function getUnitName()
    {
        return $this->unitName;
    }
    /**
     * Set unitName value
     * @param string $unitName
     * @return \StructType\InvDocCargoVO
     */
    public function setUnitName($unitName = null)
    {
        // validation for constraint: string
        if (!is_null($unitName) && !is_string($unitName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unitName, true), gettype($unitName)), __LINE__);
        }
        $this->unitName = $unitName;
        return $this;
    }
    /**
     * Get eventId value
     * @return string|null
     */
    public function getEventId()
    {
        return $this->eventId;
    }
    /**
     * Set eventId value
     * @param string $eventId
     * @return \StructType\InvDocCargoVO
     */
    public function setEventId($eventId = null)
    {
        // validation for constraint: string
        if (!is_null($eventId) && !is_string($eventId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventId, true), gettype($eventId)), __LINE__);
        }
        $this->eventId = $eventId;
        return $this;
    }
    /**
     * Get eventName value
     * @return string|null
     */
    public function getEventName()
    {
        return $this->eventName;
    }
    /**
     * Set eventName value
     * @param string $eventName
     * @return \StructType\InvDocCargoVO
     */
    public function setEventName($eventName = null)
    {
        // validation for constraint: string
        if (!is_null($eventName) && !is_string($eventName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventName, true), gettype($eventName)), __LINE__);
        }
        $this->eventName = $eventName;
        return $this;
    }
    /**
     * Get reasonId value
     * @return string|null
     */
    public function getReasonId()
    {
        return $this->reasonId;
    }
    /**
     * Set reasonId value
     * @param string $reasonId
     * @return \StructType\InvDocCargoVO
     */
    public function setReasonId($reasonId = null)
    {
        // validation for constraint: string
        if (!is_null($reasonId) && !is_string($reasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonId, true), gettype($reasonId)), __LINE__);
        }
        $this->reasonId = $reasonId;
        return $this;
    }
    /**
     * Get reasonName value
     * @return string|null
     */
    public function getReasonName()
    {
        return $this->reasonName;
    }
    /**
     * Set reasonName value
     * @param string $reasonName
     * @return \StructType\InvDocCargoVO
     */
    public function setReasonName($reasonName = null)
    {
        // validation for constraint: string
        if (!is_null($reasonName) && !is_string($reasonName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonName, true), gettype($reasonName)), __LINE__);
        }
        $this->reasonName = $reasonName;
        return $this;
    }
    /**
     * Get eventDate value
     * @return string|null
     */
    public function getEventDate()
    {
        return $this->eventDate;
    }
    /**
     * Set eventDate value
     * @param string $eventDate
     * @return \StructType\InvDocCargoVO
     */
    public function setEventDate($eventDate = null)
    {
        // validation for constraint: string
        if (!is_null($eventDate) && !is_string($eventDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventDate, true), gettype($eventDate)), __LINE__);
        }
        $this->eventDate = $eventDate;
        return $this;
    }
    /**
     * Get eventTime value
     * @return string|null
     */
    public function getEventTime()
    {
        return $this->eventTime;
    }
    /**
     * Set eventTime value
     * @param string $eventTime
     * @return \StructType\InvDocCargoVO
     */
    public function setEventTime($eventTime = null)
    {
        // validation for constraint: string
        if (!is_null($eventTime) && !is_string($eventTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventTime, true), gettype($eventTime)), __LINE__);
        }
        $this->eventTime = $eventTime;
        return $this;
    }
    /**
     * Get cityName value
     * @return string|null
     */
    public function getCityName()
    {
        return $this->cityName;
    }
    /**
     * Set cityName value
     * @param string $cityName
     * @return \StructType\InvDocCargoVO
     */
    public function setCityName($cityName = null)
    {
        // validation for constraint: string
        if (!is_null($cityName) && !is_string($cityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cityName, true), gettype($cityName)), __LINE__);
        }
        $this->cityName = $cityName;
        return $this;
    }
    /**
     * Get townName value
     * @return string|null
     */
    public function getTownName()
    {
        return $this->townName;
    }
    /**
     * Set townName value
     * @param string $townName
     * @return \StructType\InvDocCargoVO
     */
    public function setTownName($townName = null)
    {
        // validation for constraint: string
        if (!is_null($townName) && !is_string($townName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($townName, true), gettype($townName)), __LINE__);
        }
        $this->townName = $townName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvDocCargoVO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
