<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for YurticikargoWSException StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:YurticikargoWSException
 * @subpackage Structs
 */
class YurticikargoWSException extends AbstractStructBase
{
    /**
     * The errorCode
     * @var int
     */
    public $errorCode;
    /**
     * The errText
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $errText;
    /**
     * Constructor method for YurticikargoWSException
     * @uses YurticikargoWSException::setErrorCode()
     * @uses YurticikargoWSException::setErrText()
     * @param int $errorCode
     * @param string $errText
     */
    public function __construct($errorCode = null, $errText = null)
    {
        $this
            ->setErrorCode($errorCode)
            ->setErrText($errText);
    }
    /**
     * Get errorCode value
     * @return int|null
     */
    public function getErrorCode()
    {
        return $this->errorCode;
    }
    /**
     * Set errorCode value
     * @param int $errorCode
     * @return \StructType\YurticikargoWSException
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->errorCode = $errorCode;
        return $this;
    }
    /**
     * Get errText value
     * @return string|null
     */
    public function getErrText()
    {
        return $this->errText;
    }
    /**
     * Set errText value
     * @param string $errText
     * @return \StructType\YurticikargoWSException
     */
    public function setErrText($errText = null)
    {
        // validation for constraint: string
        if (!is_null($errText) && !is_string($errText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errText, true), gettype($errText)), __LINE__);
        }
        $this->errText = $errText;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\YurticikargoWSException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
